#define private public
#include <PSX/System/IOPorts/interrupt_io.hpp>
#include <PSX/System/syscalls.h>
#include <PSX/Timer/timer.hpp>
#undef private

namespace JabyEngine {
    size_t GlobalTime :: global_counter = 0;

    namespace Timer {
        uint32_t interrupt_verifier() {
            const auto irq_status = Interrupt::Status.read();

            if(irq_status.is_bit_set(Interrupt::Timer0)) {
                return ExecuteHandler;
            }
            
            else {
                return SkipHandler;
            }
        }

        uint32_t interrupt_handler(uint32_t) {
            GlobalTime::global_counter++;
            return 0;
        }
    }
}